#include "queue1.h"
#include <iostream>

using namespace std;

Queue1::Queue1(int size)
{
	capacity = size;
	length = 0;
	dizi = new int[capacity];
	cout << "Yeni kuyruk tanimlandi. Kapasitesi: " << capacity << endl;
	cout << "Kuyrugun hafizadaki adresi: " << this << endl;
}

Queue1::~Queue1()
{
	cout << "Kuyruk yok edildi..." << endl;
	delete [] dizi;
}

void Queue1::push(int val)
{
	if (length >= capacity)
	{
		capacity = 2 * capacity;
		int * gecici_dizi = new int[capacity];
		for (int i=0;i<length;++i){
			gecici_dizi[i] = dizi[i];
		}
		delete [] dizi;
		dizi = gecici_dizi;
		cout << "Yeni Kapasite: " << capacity << endl;
	}

	dizi[length] = val;
	length++;
	cout << "Kuyruga yeni eleman eklendi: " << val << endl;
	cout << "Kuyruktaki eleman sayisi: " << length << endl;
}

void Queue1::print(){
	if (length > 0) {
		for (int i=0;i<length;++i){
			cout << dizi[i] << ",";
		}
		cout << endl;
	} else {
		cout << "Kuyrukta hic eleman yok!" << endl;
	}
}

void Queue1::empty(){
	length = 0;
}

void Queue1::pop(){
	if (length > 0){
		cout << "Kuyruktan eleman silindi: " << front() << endl;
		length--;
		cout << "Kuyruktaki eleman sayisi: " << length << endl;
		for(int i=0;i<length;i++){
			dizi[i] = dizi[i+1];
		}
	} else {
		cout << "Kuyrukta hic eleman yok!" << endl;
	}
}

int Queue1::front(){
	return dizi[0];
}

int Queue1::getLength(){
	return length;
}

